//#############################################################################
//
//  main_lib.js
//
//    JavaScript Client Library
//
//    See the file "license.txt" for information on usage and
//    redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
////
//#############################################################################

ie5=document.all&&document.getElementById
ns6=document.getElementById&&!document.all
            
if ( navigator.platform == "MacPPC" ) {
    clientPlatform = '1'
} else {
    clientPlatform = '0'
}

if ( navigator.appName == "Netscape" ) {
    browserType = "ne"
} else if ( navigator.appName.indexOf("Microsoft") != -1 ) {
    browserType = "ie"
}

if ((navigator.appVersion.indexOf("Win") != -1)) {
    platformWin = true
} else {
    platformWin = false
}

if ((navigator.appVersion.indexOf("Mac") != -1)) {
    platformMac = true
} else {
    platformMac = false
}

cbe            = "cbe"
bgcolor        = "#CCCCCC"
lastElement    = ""
lastRow        = ""
checkedStatus  = true
pageSubmited   = false
moreThanOne    = ""
singleElement  = ""
selectedObject = ""
elementBgcolor = "#FFFFFF"
menuMarColor   = "#4E5A6C"
rowMarkColor   = "#BBD4EB"
checkedColor   = rowMarkColor
submenu        = "_dummy_"
hidePopUp      = ""
moreThanOne    = false
menuToHide     = ['PopFileBox','PopEditBox','PopViewBox','PopSelectHelpBox','PopPwdBox','PopApplicationBox','PopHelpBox','PopJobBox','PopBskPosBox','PopBasketBox']
markedMenu     = '_dummy_';
fixButtonHeight = 60;
releaseTime     = 10000;

function isBrowserBlocked() {
    if (!pageSubmited) return false;
    return true;
}

function blockBrowser(state) {
    pageSubmited = state
    //if state is true to block, start a timeout to reset the pageSubmited
    if (pageSubmited && typeof(browserStateTimer) !== 'number') {
        browserStateTimer = setTimeout('pageSubmited = false;browserStateTimer = "undefined"',releaseTime);
    }
}
function waitBox(box) {
    var func = function() { nowWait(box);}; 
    waitBoxTimer = setTimeout(func,100);
}
function nowWaitXXL(frame) {
    document.getElementById('ajxlodXXL').style.visibility = "visible";
}
function nowWait(box) {
    if ( !document.getElementById('ajxlod') ) waitboxTpl.append(box);
    document.getElementById('ajxlod').style.visibility = "visible";
}
function hideWait(frame) {
    if (typeof(waitBoxTimer) !== 'undefined') clearTimeout(waitBoxTimer);
    if ( !document.getElementById('ajxlod') ) return;
    document.getElementById('ajxlod').style.visibility = "hidden";
}
function toolReady() {
    window.parent.toolFrame = true
    blockFunctions();
}
function menuReady() {
    window.parent.menuFrame = true
    document.oncontextmenu=new Function('return false')
    document.onselectstart=new Function('return false')
}
function infoReady() {
    window.parent.infoFrame = true
    blockFunctions();
}
function blockFunctions() {
    document.oncontextmenu=new Function('return false')
    document.onselectstart=new Function('return false')
    document.onmousedown=new Function('return false')
}
function agentSetup(eButton) {
    MenuSwitchToolbar('agent')
}
function popupMenu(e,box) {
    popupHide();
    var evt = (e) ? e : ((event) ? event : null);
    var elm = (evt.target) ? evt.target : evt.srcElement;
    var nod = elm.parentNode
    if ( document.getElementById(box) ) {
        var menuBox = document.getElementById(box);
        var frWidth = Ext.getCmp('northmenu').getWidth();
        var posLeft = parseInt(nod.offsetLeft);
        var rSpace  = frWidth - posLeft;
        if (rSpace<menuBox.offsetWidth) {
            menuBox.style.left = posLeft + nod.offsetWidth - menuBox.offsetWidth + 'px';
        } else {
            menuBox.style.left = posLeft + 'px';
        }
        menuBox.style.top = Ext.getCmp('northmenu').getHeight() + 'px';
        menuBox.style.visibility = "visible";
    }
}
function popupHide(e) {
    var eve=window.event? event : e
    //#check if button is not right
    if (eve && (eve.button == 2 || eve.ctrlKey) ) return false;
    if ( lastRow != "" ) popupUnmark(lastRow)
    for ( menuBox in menuToHide ) {
        if ( document.getElementById(menuToHide[menuBox]) ) {
            var menuDa = document.getElementById(menuToHide[menuBox]).style.visibility
            if ( menuToHide[menuBox] == markedMenu && menuDa == 'visible' ) {
                hideMenu(markedMenu);
            }
            document.getElementById(menuToHide[menuBox]).style.visibility = "hidden";
        }
    }
    if ( document.getElementById(submenu) ) {
        document.getElementById(submenu).style.visibility = "hidden";
    }
    if ( document.getElementById('hintHowToNewBox') ) {
        document.getElementById('hintHowToNewBox').style.visibility = "hidden";
    }
    if ( document.getElementById('msizebox') ) {
        document.getElementById('msizebox').style.visibility = "hidden";
    }
}
function hideMenu(box) {
    if ( document.getElementById(box+'_top') ) {
        document.getElementById(box+'_top').className=box;
    }
}
function popupSubmenu(menu,box,wid) {
    var wid = parseInt(wid)
    var nod = menu.parentNode;
    if ( document.getElementById(box) ) {
        submenu = box;
        var posLeft = parseInt(nod.style.left) + wid - 7 + 'px';
        var posTop  = parseInt(nod.style.top) + parseInt(menu.style.top) + 2 + 'px';
        document.getElementById(box).style.left = posLeft;
        document.getElementById(box).style.top  = posTop;
        document.getElementById(box).className='PopLogBox';
        document.getElementById(box).style.visibility = "visible";
    }
}
function popupButton(e,box) {
    popupHide();
    var evt = (e) ? e : ((event) ? event : null);
    var elm = (evt.target) ? evt.target : evt.srcElement;
    var nod = elm.parentNode
    if ( document.getElementById(box) ) {
        var menuBox  = document.getElementById(box);
        var frHeight = Ext.getCmp('centercenter').getHeight()
        menuBox.style.top = frHeight - 60 - menuBox.offsetHeight + 'px';
        menuBox.style.left = '18px';
        menuBox.style.visibility = "visible";
    }
}
function popupBox(e,box) {
    popupHide();
    var evt = (e) ? e : ((event) ? event : null);
    var elm = (evt.target) ? evt.target : evt.srcElement;
    if ( document.getElementById(box) ) {
        var posLeft = parseInt(elm.offsetLeft) + parseInt(elm.offsetWidth) - 12 + 'px'
        var posTop  = parseInt(elm.offsetTop)  + parseInt(window.pageYOffset) + parseInt(elm.offsetHeight) + 4 + 'px'
        document.getElementById(box).style.left = posLeft;
        document.getElementById(box).style.top  = posTop
        document.getElementById(box).style.visibility = "visible";
    }
}
function hideSubmenu() {
    if ( document.getElementById(submenu) ) {
        document.getElementById(submenu).style.visibility = "hidden";
    }
}
function popupMark(eButton) {
    popupUnmark(lastRow)
    if ( eButton ) {
        eButton.className='PopLogRow1M';
        lastRow = eButton
    }
}   
function popupUnmark(eButton) {
    if ( eButton ) {
        eButton.className='PopLogRow1';
    }
}
//# row mark
function elementMark(eButton,evt) {
    if ( evt.metaKey || ( evt.ctrlKey && !platformMac ) ) {
        if ( document.getElementById(cbe+eButton.id).checked == true ) {
            popupUnMarkElement(eButton)
            return
        }
        popupMarkElement(eButton)
        singleElement = document.getElementById(cbe+eButton.id).value
        moreThanOne = true
        lastElement = eButton
    } else if ( evt.shiftKey ) {
        checkRangeElements(eButton)
        lastElement = eButton
    } else {
        if ( moreThanOne ) {
            deCheckAllElements()
        }
        if ( lastElement != "" ) {
            popupUnMarkElement(lastElement)
        }
        if ( eButton ) {
            elementBgcolor = eButton.style.backgroundColor
            popupMarkElement(eButton)
            singleElement = document.getElementById(cbe+eButton.id).value
            lastElement = eButton
        }
    }
}   
function checkRangeElements(eButton) {
        var currentRow = eButton.id
        for ( var row = 0 ; row < elementCount ; row++ ) {
            if ( document.getElementById(cbe+row).checked ) {
                if ( typeof firstRow == 'undefined' ) {
                    var firstRow = row
                }
                var lastRow = row
            }
        }
        if ( typeof firstRow == 'number' ) {
            if ( currentRow < firstRow ) {
                var startRow = currentRow
                var endRow   = lastRow
            } else if ( currentRow > lastRow ) {
                var startRow = firstRow
                var endRow   = currentRow
            } else {
                var startRow = firstRow
                var endRow   = lastRow
            }
        } else {
            var startRow = currentRow
            var endRow   = currentRow
        }
        if ( startRow == endRow ) moreThanOne = false;
        for ( var row = startRow ; row <= endRow ; row++ ) {
            var elm  = document.getElementById(row)
            if ( row > currentRow && currentRow > startRow ) {
                popupUnMarkElement(elm)
            } else {
                popupMarkElement(elm)
            }
        }
        moreThanOne = true
}
function deCheckAllElements() {
        numberElements  = 0
        selectedelements = ""
        elementurl      = ""
        elementType     = ""
        for ( var row = 0 ; row < elementCount ; row++ ) {
            var elm  = document.getElementById(row)
            popupUnMarkElement(elm)
        }
        checkedStatus   = false
        moreThanOne     = false
}
function popupMarkElement(eButton) {
    if ( eButton ) {
        document.getElementById(cbe+eButton.id).checked = true
        eButton.style.backgroundColor = rowMarkColor;
    }
}   
function popupUnMarkElement(eButton) {
    if ( eButton ) {
        document.getElementById(cbe+eButton.id).checked = false
        eButton.style.backgroundColor = elementBgcolor;
        singleElement = ""
    }
}   
//# contex menu in file listing  
function contextMenu(e) {
    var elm = document.getElementById('loaderdiv').parentNode;    
	var posx = 0;
	var posy = 0;
	if (!e) var e = window.event;
	if (e.pageX || e.pageY) 	{
		posx = e.pageX + elm.scrollLeft;
		posy = e.pageY + elm.scrollTop;
	}
	else if (e.clientX || e.clientY) 	{
		posx = e.clientX + document.body.scrollLeft
			+ document.documentElement.scrollLeft;
		posy = e.clientY + document.body.scrollTop
			+ document.documentElement.scrollTop;
	}
	var offsetX = Ext.getCmp('westtool').getWidth();
	var offsetY = Ext.getCmp('northmenu').getHeight();
	posx -= offsetX;
	posy -= offsetY;
    menuBox=document.getElementById("PopEditBox")
    // if the left/right distance isn't enough to accomodate the width of the context menu
	var rightedge=Ext.getCmp('centercenter').getWidth() - posx + document.body.scrollLeft + document.documentElement.scrollLeft;
	var bottomedge=Ext.getCmp('centercenter').getHeight() - posy + document.body.scrollTop + document.documentElement.scrollTop;
    if (rightedge<menuBox.offsetWidth) {
        menuBox.style.left = posx - menuBox.offsetWidth  +'px'
    } else {
        menuBox.style.left = posx +'px';
    }
    if (bottomedge<menuBox.offsetHeight) {
         menuBox.style.top = posy - menuBox.offsetHeight  +'px'
    } else {
        menuBox.style.top  = posy +'px';
    }
    menuBox.style.visibility="visible"
    return false
}
//# contex menu in resource listing  
function contextMenuExt(e) {
	var posx = 0;
	var posy = 0;
	if (!e) var e = window.event;
	if (e.pageX || e.pageY) 	{
		posx = e.pageX;
		posy = e.pageY;
	}
	else if (e.clientX || e.clientY) 	{
		posx = e.clientX + document.body.scrollLeft
			+ document.documentElement.scrollLeft;
		posy = e.clientY + document.body.scrollTop
			+ document.documentElement.scrollTop;
	}
	var offsetX = Ext.getCmp('westtool').getWidth();
	var offsetY = Ext.getCmp('northmenu').getHeight();
	posx -= offsetX;
	posy -= offsetY;
    menuBox=document.getElementById("PopEditBox")
    // if the left/right distance isn't enough to accomodate the width of the context menu
	var rightedge=Ext.getCmp('centercenter').getWidth() - posx + document.body.scrollLeft + document.documentElement.scrollLeft;
	var bottomedge=Ext.getCmp('centercenter').getHeight() - posy + document.body.scrollTop + document.documentElement.scrollTop;
    if (rightedge<menuBox.offsetWidth) {
        menuBox.style.left = posx - menuBox.offsetWidth  +'px'
    } else {
        menuBox.style.left = posx +'px';
    }
    if (bottomedge<menuBox.offsetHeight) {
         menuBox.style.top = posy - menuBox.offsetHeight  +'px'
    } else {
        menuBox.style.top  = posy +'px';
    }
    menuBox.style.visibility="visible"
    return false
}
function checkAllElements() {
        numberElements  = 0
        selectedelements = ""
        var elm         = ""
        var inloop      = ""
        var outloop     = ""
        for ( var row = 0 ; row < elementCount ; row++ ) {
            checkBox = cbe+row
            document.getElementById(checkBox).checked = true
            document.getElementById(checkBox).parentNode.parentNode.style.backgroundColor = rowMarkColor
            elm             = document.getElementById(checkBox).value
            selectedelements = selectedelements+inloop
            inloop          = elm+"\r"
            outloop         = elm
            elementurl      = document.getElementById(checkBox).value
            elementType     = document.getElementById(checkBox).name
            numberElements++
        }
        selectedelements = selectedelements+outloop        
        checkedStatus   = true
        moreThanOne     = true
}
function checkForSingle() {
    if ( numberElements > 1 ) {
        alert(document.msgForm.jsmsg2.value)
        return 0
    }
    if ( numberElements == 0 ) {
        alert(document.msgForm.jsmsg1.value)
        return 0
    }
    return 1
}
function checkForMulti() {
    if ( numberElements < 1 ) {
        alert(document.msgForm.jsmsg18.value)
        return 0
    }
    return 1
}
function actSelected(eButton,evt) {
    popupHide()
    elementMark(eButton,evt)
}
function importElement(obj,eve) {
    if ( confirm(document.msgForm.jsmsg33.value) ) {
        document.getElementById('upload_input').click();
    }
}
function startImport() {
    if ( document.uploadForm.attachment.value == "" ) return;
    document.uploadForm.restype.value = restype;
    document.uploadForm.submit();
}
function exportElement() {
    popupHide()
    getSelctedResources();
    if ( checkForMulti() == 0 ) return
    document.resExport.caller.value = "resExport";
    document.resExport.restype.value = restype;
    document.resExport.selected.value = Ext.encode(selectedelements);
    document.resExport.submit();
}
function jslog() {
    if (document.errorForm) {
        var msg = '';
        if ( document.errorForm.pageErrorMsg.value != "" ) {
            msg = document.errorForm.pageErrorMsg.value
        } else if ( document.errorForm.message.value != "" ) {
            msg = document.errorForm.message.value
        }
        if (Ext && msg != '' ) {
			Ext.MessageBox.alert({
			   title: $$('Note'), 
			   msg: msg+'<br>',
			   minHeight: 150,
			   minWidth: 450,
			   buttons:  Ext.MessageBox.OK
			});
        } else if ( msg != '' ) {
            alert(msg);
        }
    }
}
function ialert(msg) {
    if (typeof(msg) !== 'undefined' && msg != null && msg != "" ) {
        if (Ext && msg != '' ) {
            Ext.MessageBox.alert('Note', msg );
        } else if ( msg != '' ) {
            alert(msg);
        }
    }
}
function checkIfRoot(isAdminUser) {
    if ( isAdminUser == 0 ) {
        alert(document.msgForm.jsmsg9.value)
        return 0
    }
    return 1
}
function actLinkRes(typ,res) {
    var elementurl  = '';
    var elementType  = typ;
    document.hammerForm.selected.value  = Ext.encode(res);
    openWindow(elementType,elementurl)
}
//#############################################################################
// window functions
//#############################################################################
function openWindow(elementType, elementurl) {
    if ( client[elementType] && client[elementType].open ) {
        win = window.open("", client[elementType].open.target, client[elementType].open.wsize);
        win.focus();
        winOpenClose(win);
        document.hammerForm.elementType.value = elementType;
        document.hammerForm.elementCall.value = "open";
        document.hammerForm.elementurl.value  = elementurl;
        document.hammerForm.target            = client[elementType].open.target;
        document.hammerForm.submit();
    } else {
        alert(document.msgForm.jsmsg10.value + ': ' +elementType)
    }
}
function newElement(eButton) {
    popupHide()
    if ( client[restype] && client[restype].create ) {
        win = window.open("", client[restype].create.target, client[restype].create.wsize);
        win.focus();
        winOpenClose(win);
        document.hammerForm.elementCall.value = "create";
        document.hammerForm.elementType.value = restype;
        document.hammerForm.elementurl.value  = "";
        document.hammerForm.selected.value    = "";
        document.hammerForm.target            = client[restype].create.target;
        document.hammerForm.submit();
    } else {
        elementWindow = window.open(eButton.id,"newelementframe","height=160,width=420,scrollbars=no,resizable");
        elementWindow.focus();
    }
}
function newElement1(elementType, application) {
    popupHide()
    win = window.open("", client[elementType][application].target, client[elementType][application].wsize);
    win.focus();
    winOpenClose(win);
    document.hammerForm.elementType.value = elementType;
    document.hammerForm.elementCall.value = application;
    document.hammerForm.process.value     = "";
    document.hammerForm.elementurl.value  = "";
    document.hammerForm.selected.value    = "";
    document.hammerForm.target            = client[elementType][application].target;
    document.hammerForm.submit();
}
function filePicker(eButton) {
    //popupHide()
    pickerFrame = window.open("","pickerFrame","height=500,width=650,scrollbars=auto,resizable,status");
    pickerFrame.focus();
    winOpenClose(pickerFrame);
    document.pickerForm.submit();
}
function jobMonitor(eButton) {
    popupHide()
    jobMonitorFrame = window.open("","jobMonitorFrame","height=550,width=1000,scrollbars=auto,resizable");
    jobMonitorFrame.focus();
    winOpenClose(jobMonitorFrame);
    document.jobMonitorForm.submit();
}
function aboutPresSTORE(eButton) {
    popupHide()
    aboutFrame = window.open("","aboutFrame","height=300,width=400,scrollbars=no,resizable");
    //aboutFrame.resizeTo(400, 350);
    aboutFrame.focus();
    winOpenClose(aboutFrame);
    document.windowForm.target = 'aboutFrame';
    document.windowForm.action = eButton.id;
    document.windowForm.submit();
}
function updateP5(eButton) {
    popupHide()
    updateFrame = window.open("","updateFrame","height=680,width=650,scrollbars=no,resizable");
    updateFrame.focus();
    winOpenClose(updateFrame);
    document.windowForm.target = 'updateFrame';
    document.windowForm.action = eButton.id;
    document.windowForm.submit();
}
function advancedSettings(eButton) {
    popupHide()
    updateFrame = window.open("","advancedSettingsFrame","height=680,width=650,scrollbars=no,resizable");
    updateFrame.focus();
    winOpenClose(updateFrame);
    document.windowForm.target = 'advancedSettingsFrame';
    document.windowForm.action = eButton.id;
    document.windowForm.submit();
}
function queryLog(eButton) {
    popupHide()
    queryLogFrame = window.open("","queryLogFrame","height=700,width=1000,scrollbars=no,resizable,status");
    queryLogFrame.focus();
    winOpenClose(queryLogFrame);
    document.windowForm.target = 'queryLogFrame';
    document.windowForm.action = eButton.id;
    document.windowForm.submit();
}
function newWindow(url,elementType,aktion) {
    popupHide()
    win = window.open("", client[elementType][aktion].target, client[elementType][aktion].wsize);
    win.focus();
    winOpenClose(win);
    document.windowForm.elementurl.value = '';
    document.windowForm.action = url;
    document.windowForm.elementCall.value  = aktion;
    document.windowForm.target = client[elementType][aktion].target;
    document.windowForm.submit();
}
function newResourceProc(elementType,aktion) {
    popupHide()
    win = window.open("", client[elementType][aktion].target, client[elementType][aktion].wsize);
    win.focus();
    winOpenClose(win);
    document.hammerForm.elementType.value  = elementType;
    document.hammerForm.elementCall.value  = aktion;
    document.hammerForm.elementurl.value   = "";
    document.hammerForm.target             = client[elementType][aktion].target;
    document.hammerForm.submit();
}
function commonProc(elementType,aktion) {
    popupHide()
    win = window.open("", client[elementType][aktion].target, client[elementType][aktion].wsize);
    win.focus();
    winOpenClose(win);
    document.hammerForm.elementType.value  = elementType;
    document.hammerForm.elementCall.value  = aktion;
    document.hammerForm.target             = client[elementType][aktion].target;
    document.hammerForm.submit();
}
function openRefRsrc(rsrc,elementType,action) {
    win = window.open("", client[elementType][action].target, client[elementType][action].wsize);
    win.focus();
    winOpenClose(win);
    document.hammerForm.target = client[elementType][action].target;
    document.hammerForm.selected.value = rsrc
    document.hammerForm.elementCall.value = action
    document.hammerForm.elementType.value = elementType
    document.hammerForm.submit();
}
function winOpenClose(win) {
    win.document.open();
    win.document.close();
}
function showPreview(eButton,xsize,ysize) {
    var ysize = parseInt(ysize) + 25
    var xsize = parseInt(xsize) + 25
    var imgid = eButton.id
    var wp = 'height='+ysize+',width='+xsize+',scrollbars=yes,resizable,status';
    var clipW = window.open(imgid,'previewWindow',wp);
    clipW.resizeTo(xsize,ysize)
    clipW.focus();
}
function addSelect(element,wert) {
    if ( typeof(element) != 'object' ) {
        var element  = document.getElementById(element)
    }
    var newdir   = document.createElement('OPTION')
    newdir.text  = wert   
    newdir.value = wert
    if ( ie5 ) {
        element.add(newdir);
    } else {
        element.add(newdir,null);
    }
}
//# logout
function logoutSession() {
    document.logoutForm.submit();
}
//# set/unset autologin cookie
function cookieFlag(eButton) {
    if ( eButton.checked ) {
        createCookie('autologin',loginUser,loginDays)
        if ( readCookie('autologin') == null ) {
            alert(document.msgForm.jsmsg3.value)
        }
    } else {
        eraseCookie('autologin')
    }
}
//# create a cookie
function createCookie(name,value,days) {
    if (days)
    {
        var date = new Date();
        date.setTime(date.getTime()+(days*24*60*60*1000));
        var expires = "; expires="+date.toGMTString();
    }
    else var expires = "";
    document.cookie = name+"="+value+expires+"; path=/";
}
//# read a cookie
function readCookie(name) {
    var nameEQ = name + "=";
    var ca = document.cookie.split(';');
    for(var i=0;i < ca.length;i++)
    {
        var c = ca[i];
        while (c.charAt(0)==' ') c = c.substring(1,c.length);
        if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
    }
    return null;
}
//# delete a cookie
function eraseCookie(name) {
    createCookie(name,"",-1);
}
//# open the docu frame   
function onlineDocuFrame(eButton) {
    popupHide()
    docuSpace = window.open(eButton,"DocumentationBrowser","height=700,width=1024,scrollbars=yes,resizable,status");
    docuSpace.focus();
}
//# open the docu frame   
function openArchiware(eButton) {
    popupHide()
    archSpace = window.open(eButton,"ArchiwareBrowser","height=700,width=1024,scrollbars=yes,resizable,status,toolbar,location");
    archSpace.focus();
}
//# get the position from element 
function getPos(obj) {
    var curleft = curtop = 0;
    if (obj.offsetParent) {
        curleft = obj.offsetLeft
        curtop = obj.offsetTop
        while (obj = obj.offsetParent) {
            curleft += obj.offsetLeft
            curtop += obj.offsetTop
        }
    }
    return [curleft,curtop];
}
//# replace from browser_filelist.tdp 
function supportInfo(evt) {
    popupHide()
    if ( evt.shiftKey ) {
        document.downloadSupport.caller.value = "supportInfoAll";
    } else {
        document.downloadSupport.caller.value = "supportInfo";
    }
    document.downloadSupport.submit();
}
function initCal(datefield) {
    $( datefield ).datepicker({
        dateFormat: "dd-M-yy"
    });
    $('#calimg').click(function() {
        $( datefield ).datepicker('show');
    });
}
function initCal1(datefield,format) {
    $( datefield ).datepicker({
        dateFormat: format
    });
    $('#calimg').click(function() {
        $( datefield ).datepicker('show');
    });
}
function initCal2(datefield,format) {
    $( datefield ).datepicker({
        dateFormat: format
    });
    $('#calimg2').click(function() {
        $( datefield ).datepicker('show');
    });
}
//
// new Ext part
//
(function () {
    if (!window.$$) {
        window.$$ = function(){
            var tran = [];
            var arg = arguments;
            var msg = arg[0];
            
            var idx = 0;
            var reg = /\%s/;
            var parts = [];
            
            // try to find translation
            if(typeof AWLOC !== 'undefined') {
                var translation = AWLOC[msg];
                var msg = (translation) ? translation : msg
            };
            
            //analyze the string, extract the parts with the %s identifier.
            for ( var m = reg.exec(msg); m; m = reg.exec(msg) ) {        
                parts.push(msg.substr(0, m[0][0] == "%" ? m.index : m.index));
                parts.push("%s");
                msg = msg.substr(m.index+m[0].length);
            }
            
            parts.push(msg);
                        
            //analyze the parts, replace the %s with the given arguments. beware of undefined!
            for (var i = 0; i < parts.length; ++i){
                var part = parts[i];
                
                if (part && part === "%s") {
                    var object = arg[++idx];
                
                    if (object === undefined) {
                        tran.push("%s");
                    } else {
                        tran.push(object);
                    };
                } else {
                    tran.push(part);
                };            
            };
            return tran.join('');
        };
    };
})();
function dblClickRes(record) {
    var res     = record.get('name');
    var restype = record.get('resgroup');
    var resopen = record.get('resopen');
    selectedelements = [];
    selectedelements.push(res);
    if ( client[restype] && client[restype][resopen] ) {
        win = window.open("", client[restype][resopen].target, client[restype][resopen].wsize);
        win.focus();
        winOpenClose(win);
        document.hammerForm.elementType.value = restype;
        document.hammerForm.elementCall.value = resopen;
        document.hammerForm.selected.value    = Ext.encode(selectedelements);
        document.hammerForm.target            = client[restype][resopen].target;
        document.hammerForm.submit();
    } else {
        alert(document.msgForm.jsmsg10.value + ': ' +restype)
    }
}
function getSelctedResources() {
    numberElements  = 0
    selectedelements = [];
    var thisGrid    = tabPanel.getActiveTab().getComponent(0);
    var selection   = thisGrid.getSelectionModel().getSelection();
    Ext.iterate(selection, function(obj, index) {
        var elm = obj.get('name');
        selectedelements.push(elm);
        numberElements++
    });
}
function resProc3m(aktion) {
    popupHide()
    getSelctedResources();
    if ( checkForMulti() == 0 ) return
    if ( !client[restype] ) {
        alert(document.msgForm.jsmsg11.value)
        return
    }
    win = window.open("", client[restype][aktion].target, client[restype][aktion].wsize);
    win.focus();
    winOpenClose(win);
    document.hammerForm.elementType.value  = restype;
    document.hammerForm.elementCall.value  = aktion;
    document.hammerForm.selected.value     = Ext.encode(selectedelements);
    document.hammerForm.target             = client[restype][aktion].target;
    document.hammerForm.submit();
}
function resProc3(aktion) {
    popupHide();
    getSelctedResources();
    if ( checkForSingle() == 0 ) return
    if ( !client[restype] ) {
        alert(document.msgForm.jsmsg11.value)
        return
    }
    win = window.open("", client[restype][aktion].target, client[restype][aktion].wsize);
    win.focus();
    winOpenClose(win);
    document.hammerForm.elementType.value  = restype;
    document.hammerForm.elementCall.value  = aktion;
    document.hammerForm.selected.value     = Ext.encode(selectedelements);
    document.hammerForm.target             = client[restype][aktion].target;
    document.hammerForm.submit();
}
function modeElement(mode) {
    popupHide()
    getSelctedResources();
    if ( checkForMulti() == 0 ) return
    waitBox(2);
    Ext.Ajax.request({
        url: browser_ressource,
        method: 'POST',
        params: { 
            caller: 'ajaxModeElement',
            procedure: mode+'Element',
            restype: restype,
            selectedelements: selectedelements
        },
        scope: this,
        success:function(response, options) {
            hideWait(2);
            reloadStore();
        }
    });
}
function reloadStore() {
    if (tabPanel && tabPanel.getActiveTab() )  {
        var thisStore = tabPanel.getActiveTab().getComponent(0).getStore();
        thisStore.reload();
    }
}
function reloadWS3() {
    if ( top.opener ) {
        if ( top.opener.tabPanel) {
            top.opener.reloadStore();
        }
    }
}
// functions for browser_tree
function thisVolumen(eButton) {
    popupHide();
    var browser_index = document.filelist.browser_index.value;
    var elementurl = document.getElementById('url'+eButton.id).value;
    var elementtxt = document.getElementById('txt'+eButton.id).value;
    var loginArea  = document.getElementById('lga'+eButton.id).value;
    var wststation = document.getElementById('wst'+eButton.id).value;
    var dbusage    = document.getElementById('usa'+eButton.id).value;
    var operation  = document.getElementById('opr'+eButton.id).value;
    //remove fix bottom bar as div element because it is not controlled by EXT
    rmDiv('wstreebody');
    rmDiv('loaderdiv');
    rmDiv('fixButton');
    //if (Ext.getCmp('selection_id')) Ext.getCmp('selection_id').destroy();
    Ext.getCmp('centercenter').removeAll();
    waitBox('centerdata');
    Ext.get('centerdata').load({
        url:browser_index,
        scripts:true,
        success: function(){
            hideWait();
        },
        failure: function(){
            extAlert(1,'Could not connect to server')
        }, 
        params:{
            caller: 'volumenListing',
            content: 'volumelist',
            searchFlag: 'false',
            listing: 'listing',
            elementurl: elementurl,
            elementtxt: elementtxt,
            loginArea: loginArea,
            workstation: wststation,
            dbusage: dbusage,
            operation: operation
        }
    });
}
// use existing tmp div or create new one
function getTempDiv(elm) {
    var tmpdiv = Ext.get(elm);
    if (tmpdiv) {
        return tmpdiv;
    } else {
        Ext.DomHelper.append('loaderarea', {tag: 'div', id: elm});
        return Ext.get(elm);
    }
}
// remove existing element
function rmDiv(elm) {
    var torm = Ext.get(elm);
    if (torm) {
        torm.remove();
    }
}
//for touch device view (click on icon)
function aosf(row) {
    if ( pageSubmited ) return
    var elementurl  = document.getElementById(cbe+row).value
    var elementType = document.getElementById(cbe+row).name
    if ( elementType == "Directory" || elementType == "Container" ) {
        waitBox();
        pageSubmited = true;
        var page = document.filelist.page.value;
        var ldiv = getTempDiv('loaderdiv');
        ldiv.load({url:page, scripts:true, params:{
            caller: 'nextDir',
            content: 'filelist',
            listing: 'listing',
            elementurl: elementurl,
            elementtype: document.filelist.elementtype.value,
            sortColumn: document.filelist.sortColumn.value,
            sortDirection: document.filelist.sortDirection.value,
            searchFlag: document.filelist.searchFlag.value,
            viewstyle: document.filelist.viewstyle.value,
            snapshot: document.filelist.snapshot.value,
            database: document.filelist.database.value,
            workstation: document.filelist.workstation.value
        }});
    } else {
        openWindow(elementType,elementurl)
    }
}
function prevDirDbl(eButton) {
    if ( pageSubmited ) return
    waitBox();
    pageSubmited = true;
    var page = document.filelist.page.value;
    var ldiv = getTempDiv('loaderdiv');
    ldiv.load({url:page, scripts:true, params:{
        caller: 'previousDir',
        content: 'filelist',
        listing: 'listing',
        elementurl: document.getElementById('cbi'+eButton.id).value,
        elementtype: document.filelist.elementtype.value,
        sortColumn: document.filelist.sortColumn.value,
        sortDirection: document.filelist.sortDirection.value,
        searchFlag: document.filelist.searchFlag.value,
        viewstyle: document.filelist.viewstyle.value,
        snapshot: document.filelist.snapshot.value,
        database: document.filelist.database.value,
        workstation: document.filelist.workstation.value
    }});
}
function prevDir(eButton) {
    if ( pageSubmited ) return
    waitBox();
    pageSubmited = true;
    var page = document.filelist.page.value;
    var ldiv = getTempDiv('loaderdiv');
    ldiv.load({url:page, scripts:true, params:{
        caller: 'previousDir',
        content: 'filelist',
        listing: 'listing',
        elementurl: eButton.id,
        elementtype: document.filelist.elementtype.value,
        sortColumn: document.filelist.sortColumn.value,
        sortDirection: document.filelist.sortDirection.value,
        searchFlag: document.filelist.searchFlag.value,
        viewstyle: document.filelist.viewstyle.value,
        snapshot: document.filelist.snapshot.value,
        database: document.filelist.database.value,
        workstation: document.filelist.workstation.value
    }});
}
function emptyBasket(basket) {
    popupHide()
    var page = document.filelist.page.value;
    var ldiv = getTempDiv('loaderdiv');
    waitBox();
    ldiv.load({url:page, scripts:true, params:{
        caller: 'emptyBasket',
        content: 'filelist',
        listing: 'listing',
        basket: basket,
        elementurl: document.filelist.elementurl.value,
        elementtype: document.filelist.elementtype.value,
        sortColumn: document.filelist.sortColumn.value,
        sortDirection: document.filelist.sortDirection.value,
        searchFlag: document.filelist.searchFlag.value,
        viewstyle: document.filelist.viewstyle.value,
        snapshot: document.filelist.snapshot.value,
        database: document.filelist.database.value,
        workstation: document.filelist.workstation.value
    }});
}
function sortCol(eButton) {
    if ( document.filelist.sortColumn.value == eButton ) {
        if (document.filelist.sortDirection.value == "dec" ) {
            document.filelist.sortDirection.value = "inc"
        } else {
            document.filelist.sortDirection.value = "dec"
        }
    } else {
        document.filelist.sortDirection.value = "inc"
    }
    var page = document.filelist.page.value;
    var ldiv = getTempDiv('loaderdiv');
    waitBox();
    ldiv.load({url:page, scripts:true, params:{
        caller: 'sortColumn',
        content: 'filelist',
        listing: 'listing',
        elementurl: document.filelist.elementurl.value,
        elementtype: document.filelist.elementtype.value,
        sortColumn: eButton,
        sortDirection: document.filelist.sortDirection.value,
        searchFlag: document.filelist.searchFlag.value,
        viewstyle: document.filelist.viewstyle.value,
        snapshot: document.filelist.snapshot.value,
        database: document.filelist.database.value,
        workstation: document.filelist.workstation.value
    }});
}
// sort for getting started pages
function sortCol2(eButton) {
    if ( document.resourceForm.sortColumn.value == eButton ) {
        if (document.resourceForm.sortDirection.value == "dec" ) {
            document.resourceForm.sortDirection.value = "inc"
        } else {
            document.resourceForm.sortDirection.value = "dec"
        }
    } else {
        document.resourceForm.sortDirection.value = "inc"
    }
    var page = document.resourceForm.page.value;
    Ext.get('loaderdiv').load({url:page, scripts:true, params:{
        caller: 'sortColumn',
        sortColumn: eButton,
        sortDirection: document.resourceForm.sortDirection.value,
        period: document.resourceForm.period.value
    }});
}
function changeView(eButton) {
    var page = document.filelist.page.value;
    var ldiv = getTempDiv('loaderdiv');
    waitBox();
    ldiv.load({url:page, scripts:true, params:{
        caller: 'sortColumn',
        content: 'filelist',
        listing: 'listing',
        elementurl: document.filelist.elementurl.value,
        elementtype: document.filelist.elementtype.value,
        sortColumn: 'name',
        sortDirection: document.filelist.sortDirection.value,
        searchFlag: document.filelist.searchFlag.value,
        viewstyle: eButton,
        snapshot: document.filelist.snapshot.value,
        database: document.filelist.database.value,
        workstation: document.filelist.workstation.value
    }});
}
function reload2WS() {
    var page = document.filelist.page.value;
    var ldiv = getTempDiv('loaderdiv');
    waitBox();
    ldiv.load({url:page, scripts:true, params:{
        caller: 'reload',
        content: 'filelist',
        listing: 'listing',
        elementurl: document.filelist.elementurl.value,
        elementtype: document.filelist.elementtype.value,
        sortColumn: document.filelist.sortColumn.value,
        sortDirection: document.filelist.sortDirection.value,
        searchFlag: document.filelist.searchFlag.value,
        viewstyle: document.filelist.viewstyle.value,
        snapshot: document.filelist.snapshot.value,
        database: document.filelist.database.value,
        workstation: document.filelist.workstation.value
    }});
}
function chDir(elementurl) {
    var page = document.filelist.page.value;
    var ldiv = getTempDiv('loaderdiv');
    waitBox();
    ldiv.load({url:page, scripts:true, params:{
        caller: 'changeDir',
        content: 'filelist',
        listing: 'listing',
        elementurl: elementurl,
        elementtype: document.filelist.elementtype.value,
        sortColumn: document.filelist.sortColumn.value,
        sortDirection: document.filelist.sortDirection.value,
        searchFlag: document.filelist.searchFlag.value,
        viewstyle: document.filelist.viewstyle.value,
        snapshot: document.filelist.snapshot.value,
        database: document.filelist.database.value,
        workstation: document.filelist.workstation.value
    }});
}
function setShnapShot(eButton) {
    popupHide()
    var page = document.filelist.page.value;
    var ldiv = getTempDiv('loaderdiv');
    waitBox();
    ldiv.load({url:page, scripts:true, params:{
        caller: 'setShnapShot',
        content: 'filelist',
        listing: 'listing',
        elementurl: document.filelist.elementurl.value,
        elementtype: document.filelist.elementtype.value,
        sortColumn: document.filelist.sortColumn.value,
        sortDirection: document.filelist.sortDirection.value,
        searchFlag: document.filelist.searchFlag.value,
        viewstyle: document.filelist.viewstyle.value,
        snapshot: eButton.id,
        database: document.filelist.database.value,
        workstation: document.filelist.workstation.value
    }});
}
function toDownload(eButton) {
	popupHide()
    getSelctedIndexItems()
    if ( numberElements == 0 ) {
        alert(document.msgForm.jsmsg1.value)
        return 0
    }
    document.uniForm.action = browser_index+"/download.zip";
    document.uniForm.caller.value = "toDownload";
    document.uniForm.selectedelements.value = Ext.encode(selectedelements);
    document.uniForm.submit();
}
// try to fetch values for page status and message
function testResponse(req, res) {
	// test if document has xml mime type
	if (!req.getOperation().success) {
		alert($$('Server session has expired.'))
	} else {
	    var XMLdata = req.getOperation().getResponse().responseXML;
		var attention = DQ.selectValue('attention', XMLdata);
		var message   = DQ.selectValue('message', XMLdata);
		if (typeof attention == 'undefined') {
			extAlert(1,$$('Server communication error. (Invalid XML message)'));
		} else if (attention > 0 ) {
			extAlert(attention,message);
		}
	}
}
// general Ext message
function extAlert(attention,msg) {
	if ( attention == 1 ) {
		var icon = Ext.Msg['ERROR'];
		var text = $$('Error');
	} else if ( attention == 2 ) {
		var icon = Ext.Msg['WARNING'];
		var text = $$('Warning');
	} else if ( attention == 3 ) {
		var icon = Ext.Msg['INFO'];
		var text = $$('Note');
	} else {
		var icon = '';
	}
	// br required because of line cropping
	if ( attention > 0 ) {
		Ext.MessageBox.alert({
		   title: text, 
		   msg: msg+'<br>',
		   icon: icon,
		   minHeight: 150,
		   minWidth: 350,
		   buttons:  Ext.MessageBox.OK
		});
	} 
}

// new ext functions
function getSelctedIndexItems() {
    numberElements  = 0
    selectedelements = [];
    var selection   = panel_tree.getSelectionModel().getSelection();
    Ext.iterate(selection, function(obj, index) {
        var elm = obj.get('id');
        selectedelements.push(elm);
        numberElements++
    });
}
function getCheckedElements(eButton) {
    numberElements  = 0
    selectedelements = ""
    var elm         = ""
    var inloop      = ""
    var outloop     = ""
    var selection   = panel_tree.getSelectionModel().getSelection();
    Ext.iterate(selection, function(obj, index) {
        var elm = obj.get('id');
        selectedelements = selectedelements+inloop
        inloop          = elm+"\r"
        outloop         = elm
        elementurl      = elm
        elementType     = obj.get('type');
        numberElements++
    });
    selectedelements = selectedelements+outloop
}
function newWindowZ(url,elementType,aktion) {
    popupHide()
    getSelctedIndexItems()
    if ( numberElements == 0 ) {
        alert(document.msgForm.jsmsg1.value)
        return 0
    }
    win = window.open("", client[elementType][aktion].target, client[elementType][aktion].wsize);
    win.focus();
    winOpenClose(win);
    document.windowForm.action = url;
    document.windowForm.elementCall.value  = aktion;
    document.windowForm.target = client[elementType][aktion].target;
    document.windowForm.elementurl.value = Ext.encode(selectedelements);
    document.windowForm.submit();
}
function reloadTree() {
    //store_tree.load();
    panel_tree.myReset();
}
versionCompare = function(left, right) {
    if (typeof left + typeof right != 'stringstring')
        return false;
    
    var a = left.split('.')
    ,   b = right.split('.')
    ,   i = 0, len = Math.max(a.length, b.length);
        
    for (; i < len; i++) {
        if ((a[i] && !b[i] && parseInt(a[i]) > 0) || (parseInt(a[i]) > parseInt(b[i]))) {
            return 1;
        } else if ((b[i] && !a[i] && parseInt(b[i]) > 0) || (parseInt(a[i]) < parseInt(b[i]))) {
            return -1;
        }
    }
    
    return 0;
};